

public class Spud {
  
  //the tatertush is where parts are stored when not on the body
  ArrayList tatertush = new ArrayList();

//holes are parts on the body we stick things to
  ArrayList holes = new ArrayList(8);
  
  Spud mom = null;
  Spud dad = null;
  
  int score = 0;
  
  int maxrandom = 100;
  
  int INTERCOURSE = 99;
  int ADAM_AND_EVE = 1;
  int origin;
  
  
  //a number saying how likely it is we decide to not stick a piece
  //into a hole at all (versus pulling a piece out of the tatertush)
  float emptyprobability = .2;
  
  float mutationprobability = .2;
   
  //how likely it is that we'll look at mom's side first for a given hole (vs dad's)
  float momfirstprobability = .5;
  
  //gender is turned off atm (only males)
  //String gender;
  
/*  String head;
  String eyes;
  String nose;
  String mouth;
  String larm; 
  String rarm; 
  String lear;
  String rear;*/

//constructor for the initial population of spuds
  public Spud() {
  this(null, null);
  }
    
//constructor for "evolved" spuds
public Spud(Spud mymom, Spud mydad) {
  //this spud is the product of the intercourse between two spuds
  if (mymom != null && mydad != null)
  {
  this.mom = mymom;
  this.dad = mydad;
   System.out.println("THIS IS AN EVOLVED SPUD");
  origin = INTERCOURSE;
  }
  clearSpud();
  if (origin != INTERCOURSE)
  {
    //where do the first spuds come from? truly we are makers of worlds.
    //before any reproduction happens, we have to create a spud from nothing.
    System.out.println("THIS IS AN INIIAL POPULATION SPUD");
    origin = ADAM_AND_EVE;
  }
  buildSpud();  
}
  
/*  void assignGender()
  {
    int i = random(2)
    if (i)
    {
    gender = "male";
    }
    else{
    gender = "female";
    }
  
  }*/
  
  void setScore(int myscore){
  score = myscore; 
  }
  
  int getScore(){
    return score;
  }
  
  void clearSpud()
  {
//    System.out.println("CLEARING SPUD with holes.size of "+holes.size());
  //assignGender();

  tatertush.clear();
  
  //if we do genders, vary tush contents based on gender
  if(true)
  {
  tatertush.add("hat");
  tatertush.add("eyes");
  tatertush.add("nose");
  tatertush.add("mouth");
  tatertush.add("left arm");
  tatertush.add("right arm");
  tatertush.add("left ear");
  tatertush.add("right ear");
  tatertush.add("tongue");
  tatertush.add("moustache (under previous part, ignore hole)");
  tatertush.add("glasses (over eyes if present, ignore hole)");
  }
  
 // System.out.println("holes size = "+holes.size());
 // System.out.println("tatertush size = "+tatertush.size());

  holes.clear();
  for (int i = 0; i < tatertush.size(); i++)
  {
    holes.add("");  
    //    if (holes.size() >= i && holes.get(i) != null && !isInTaterTush((String)holes.get(i)))
//    {
//      tatertush.add((String)holes.get(i));
//    }
  }
//  System.out.println("holes size = "+holes.size());
 }
  
  void buildSpud(){
   System.out.println("BUILDING SPUD");

  //pick a random home on the spud at which to start placing items
  int starthole = int(random(holes.size())); 
  //loop around from starthole to holes.size, and then 0 to starthole
  //randoming taking items out of the tush (or not) and popping them on 
    
  for (int i = starthole; i < holes.size(); i++)
   {
 //   System.out.println("filling hole"+i);
    fillHole(i);
   }
  
  for (int i = 0; i < starthole; i++)
   {
//    System.out.println("filling hole"+i);
     fillHole(i); 
   }
  }
  
  boolean isWearing(String part)
  {
   return holes.contains(part);
  }
    
  //WARNING: Returns null if the spud is wearing nothing at that hole
  String getPartWearingAtHole(int hole)
  {
   return (String) holes.get(hole);
  }
  
  boolean isInTaterTush(String part)
  {
   return tatertush.contains(part);
  }
  
  //returns false if failed
  boolean getItemFromTaterTush(String part)
  {
    if (isInTaterTush(part))
    {
      tatertush.remove(part);
      return true;
    }
    else
    {
    return false;
    }
  }
  
  
  void fillHole(int hole)
  {
  //System.out.println(origin);
  //in this case, genes have been passed down, item from mom or dad
  //(which one is random) is used to fill in the hole. 
  //with a low mutation probability, this case is the most common
  if (origin == INTERCOURSE && int(random(maxrandom)) >= maxrandom*mutationprobability)
  {
    System.out.println("hole "+hole+" being filled through intercourse");
    String currpart = null;
    //mom won the genetic lottery on this hole,
    //kid will try to inherit from mom's side first
    if (random(maxrandom) < maxrandom*momfirstprobability)
    {
      currpart = mom.getPartWearingAtHole(hole);
      if (currpart != null && getItemFromTaterTush(currpart))
      {
          holes.set(hole, currpart); 
          System.out.println("mom won, hole "+hole+" set with "+currpart+" from mom");

      }
      else
      {
          currpart = dad.getPartWearingAtHole(hole);
          if (currpart != null && getItemFromTaterTush(currpart))
          {
          holes.set(hole, currpart); 
          System.out.println("mom won, "+mom.getPartWearingAtHole(hole)+" empty or already used, hole "+hole+" set with "+currpart+" from dad");

          }
          else
          {
            //both parents were unable to pass
            //on their genes here and mutation has not
            //occured; set hole to empty
            holes.set(hole, null); 
            System.out.println("mom won, both parts empty or already used, hole "+hole+" set as empty");

          }
      }
    }
    //dad won the genetic lottery on this hole,
    //kid will try to inherit from dad's side first
    else
    {
      currpart = dad.getPartWearingAtHole(hole);
      if (currpart != null && getItemFromTaterTush(currpart))
      {
          holes.set(hole, currpart);
          System.out.println("dad won, hole "+hole+" set with "+currpart+" from dad");
 
      }
      else
      {
          currpart = mom.getPartWearingAtHole(hole);
          if (currpart != null && getItemFromTaterTush(currpart))
          {
          holes.set(hole, currpart); 
          System.out.println("dad won, "+dad.getPartWearingAtHole(hole) +" empty or already used, hole "+hole+" set with "+currpart+" from mom");
          }
          else
          {
            //both parents were unable to pass
            //on their genes here and mutation has not
            //occured; set hole to empty
            holes.set(hole, null);
           System.out.println("dad won, both parts empty or already used, hole "+hole+" set as empty"); 
          }
      }  
    }
  }
 
  //in this case, mutation has occured; hole is filled by "adam and eve" methods
  //(can also occur randomly for an intercourse spud hole; see above)
  //in this method, we simply randomly decide whether or not the hole is empty
  //if it is, we leave it empty
  //if it is not, we take a RANDOM item from the tush and place it in the hole
  else
   {
    System.out.println("hole "+hole+" being filled as a mutation");
    int j = int(random(maxrandom));
    if (j < maxrandom*emptyprobability)
    {
    //within the random probability of an empty hole, set hole as empty
    holes.set(hole, null); 
    System.out.println("hole "+hole+" being filled as empty (randomly)");
    }
    else
    {
     String myItem = getRandomItemFromTush(); 
     //if no items are left in the tush, set hole as empty
     if (myItem != null)
     {
     holes.set(hole, myItem);
     System.out.println("hole "+hole+" being filled with random item "+myItem);
     }
     else
     {
     holes.set(hole, null);
     System.out.println("hole "+hole+" being filled as empty (no items left in tush)");     
     }
    }
   }   
  }
  
  //WARNING: RETURNS NULL IF TUSH IS EMPTY
  String getRandomItemFromTush()
  {
  if (tatertush.size() > 0)
  {
  int choice = int(random(tatertush.size()));
  return (String) tatertush.remove(choice);
  }
  else
  {
    return null;
  }
  }
  
  /*  String head; - hole 0
  String eyes;
  String nose;
  String mouth;
  String larm; 
  String rarm; 
  String lear;
  String rear; - hole 8*/
  
  void printSpudDirections(PrintWriter output)
  {
  System.out.println("Place the " + (String) holes.get(0) + " in the head hole,"+(String) holes.get(0)+",0");
  System.out.println("Place the " + (String) holes.get(1) + " in the eyes hole,"+(String) holes.get(1)+",1");
  System.out.println("Place the " + (String) holes.get(2) + " in the nose hole,"+(String) holes.get(2)+",2");
  System.out.println("Place the " + (String) holes.get(3) + " in the mouth hole,"+(String) holes.get(3)+",3");
  System.out.println("Place the " + (String) holes.get(4) + " in the left arm hole,"+(String) holes.get(4)+",4");
  System.out.println("Place the " + (String) holes.get(5) + " in the right arm hole,"+(String) holes.get(5)+",5");
  System.out.println("Place the " + (String) holes.get(6) + " in the left ear hole,"+(String) holes.get(6)+",6");
  System.out.println("Place the " + (String) holes.get(7) + " in the right ear hole,"+(String) holes.get(7)+",7");
  output.println("Place the " + (String) holes.get(0) + " in the head hole,"+(String) holes.get(0)+",0");
  output.println("Place the " + (String) holes.get(1) + " in the eyes hole,"+(String) holes.get(1)+",1");
  output.println("Place the " + (String) holes.get(2) + " in the nose hole,"+(String) holes.get(2)+",2");
  output.println("Place the " + (String) holes.get(3) + " in the mouth hole,"+(String) holes.get(3)+",3");
  output.println("Place the " + (String) holes.get(4) + " in the left arm hole,"+(String) holes.get(4)+",4");
  output.println("Place the " + (String) holes.get(5) + " in the right arm hole,"+(String) holes.get(5)+",5");
  output.println("Place the " + (String) holes.get(6) + " in the left ear hole,"+(String) holes.get(6)+",6");
  output.println("Place the " + (String) holes.get(7) + " in the right ear hole,"+(String) holes.get(7)+",7");

  }  
  
  //takes a piece and sticks it on a hole
  boolean buildSpudManual(int hole, String part)
  {
   if (getItemFromTaterTush(part))
   {
   holes.set(hole, part);
   return true;
   }
   else
   {
   return false;
   }
  }
    
}
