PrintWriter output;

void setup() 
{

Spud[] myspuds = new Spud[10];  
Spud[] sortedspuds = new Spud[10];
Spud[] newspuds = new Spud[10];

//THIS CODE WAS USED TO CREATE INITIAL GROUP OF SPUDS
//(generation 1)
for (int i = 0; i < 10; i++)
{
  myspuds[i] = new Spud();
}

//we construct our spuds and MANUALLY collect feedback.
//feedback is MANUALLY added directly to the file as so:
//where it says "FOR SPUD N:"
//ADD A LINE FOLLOWING IT SAYING
//"#2"
//where 2 is the number of votes calling it "awesome" it has received.
//manual file editing is ok because we're hand-constructing potato heads 
//and manually scraping MT data anyway

//ok, assuming our input file is revised with the
//vote data, 
//THIS CODE READS IN LAST GENERATION OF SPUDS
String lines[] = loadStrings ("generation8.txt");
println("there are " + lines.length + " lines");
for (int i=0; i < lines.length; i++) {
  if (i % 10 == 0)
  {
  //create the new spud and clear it
  myspuds[i / 10] = new Spud();
  myspuds[i / 10].clearSpud();
  }
  else if (i % 10 == 1)
  {
  //with that new spud, set its score to the number on the line
  //(after the # tag)
  myspuds[i / 10].setScore(int(lines[i].substring(1)));
  System.out.println(myspuds[i/10].getScore());
  }
  else
  {
   String[] todo = split(lines[i], ',');
   //ignore todo0
   String todopart = todo[1];
   int todohole = int(todo[2]);
   myspuds[i / 10].buildSpudManual(todohole, todopart);
  }
}

//we sort the spuds by fitness score
//TODO: this algorithm is slow.
for (int i = 0; i < sortedspuds.length; i++)
  {
  int currmax = -1;
  int currmaxpos = -1;
  for (int j = 0; j < myspuds.length - i; j++)
    {
    if (myspuds[j] != null && myspuds[j].getScore() > currmax)
      {
      currmax = myspuds[j].getScore();
      currmaxpos = j;
      sortedspuds[i] = myspuds[j];
      }
    }
  for (int j = currmaxpos; j < myspuds.length - i - 1; j++)
    {
    myspuds[j] = myspuds[j+1];
    }
  myspuds[myspuds.length-i-1] = null;  
 }

//double-check sort
for (int i = 0; i < sortedspuds.length; i++)
{
 System.out.print(sortedspuds[i].getScore()+" "); 
}

//the top 4 spuds will all reproduce with each other, including themselves
//(to create 4+3+2+1 or exactly 10 more spuds in the next generation)
//Ties in fitness are automatically broken by order 
//found during search (position in file) by virtue of sort algorithm.

int newcount = 0;
for (int i = 0; i < 4; i++)
{
 for (int j = i; j< 4; j++)
  {
   newspuds[newcount] = new Spud(sortedspuds[i], sortedspuds[j]);
   newcount++;
  } 
}



//THIS CODE PRINTS AND SAVES NEXT GENERATION OF SPUDS
//there is, literally, a one in a hundred million chance we'll write over the old file
output = createWriter("generation"+int(random(100000000))+".txt");
for (int i = 0; i < 10; i++)
{
  System.out.println("FOR SPUD "+(i+1)+":");
  System.out.println("#");
  output.println("FOR SPUD "+(i+1)+":");  
  output.println("#");
  newspuds[i].printSpudDirections(output);
}
output.flush();
output.close();


//THIS CODE SERVES AS UNIT CASES
//FOR TESTING GENERATION OF BOTH NEW SPUDS
//AND GENETICALLY EVOLVED SPUDS
/*Spud mom = new Spud();
mom.printSpudDirections();
Spud dad = new Spud();
dad.printSpudDirections();
Spud kid = new Spud(mom, dad);
kid.printSpudDirections();*/
}


//Rinse, repeat forever (draw loop is our control loop)
void draw() 
{
  
}
